local assets=
{
	Asset("ANIM", "anim/hktherm.zip"),
	Asset("ANIM", "anim/swap_hktherm.zip"),
	Asset("ATLAS", "images/inventoryimages/hktherm.xml")
}

    
local prefabs =
{
	"explode_small"
}


----

local function OnExplodeFn(inst)
    inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_explo")

    local explode = SpawnPrefab("explode_small")
    local pos = inst:GetPosition()
    explode.Transform:SetPosition(pos.x, pos.y, pos.z)

    --local explode = PlayFX(pos,"explode", "explode", "small")
    explode.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
    explode.AnimState:SetLightOverride(1)
	inst.SoundEmitter:KillSound("hiss")
end

local function OnDropped(inst)
    inst.AnimState:PlayAnimation("idle")
end

local function OnThrown(inst, owner, target)
    if target ~= owner then
		inst.AnimState:PlayAnimation("throw", true)
    end
    inst.AnimState:PlayAnimation("spin_loop", true)
end

local function OnHit(inst, target)
    if target ~= nil and target:IsValid() then
         inst.AnimState:PlayAnimation("idle")
		 inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_fuse_LP", "hiss")
		 --inst.components.explosive:OnBurnt()
		 inst:DoTaskInTime(3, function() inst.components.explosive:OnBurnt() end)
		 
	end
end

local function OnMiss(inst, target)
    if target ~= nil and target:IsValid() then
		inst.AnimState:PlayAnimation("idle")
		inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_fuse_LP", "hiss")
		 --inst.components.explosive:OnBurnt()
		inst:DoTaskInTime(3, function() inst.components.explosive:OnBurnt() end)
	end
end

--------

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst .entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	
    inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
    
    anim:SetBank("boomerang")
    anim:SetBuild("hktherm")
    anim:PlayAnimation("idle")
    anim:SetRayTestOnBB(true);
    
    inst:AddTag("projectile")
    inst:AddTag("thrown")
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.BOOMERANG_DAMAGE*0.5)
    inst.components.weapon:SetRange(TUNING.BOOMERANG_DISTANCE, TUNING.BOOMERANG_DISTANCE+2)
    ------
    
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = 10
	
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(50)
    inst.components.projectile:SetOnThrownFn(OnThrown)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnMiss)
    
	inst:AddComponent("explosive")
    inst.components.explosive:SetOnExplodeFn(OnExplodeFn)
    inst.components.explosive.explosivedamage = TUNING.GUNPOWDER_DAMAGE*1.5
	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/hktherm.xml"
    inst.components.inventoryitem:SetOnDroppedFn(OnDropped)
    
   	inst:AddComponent("inspectable")
    
    inst:AddComponent("equippable")
    
    return inst
end

return Prefab( "common/inventory/hktherm", fn, assets, prefabs) 